searchData={"content_type":"text/markdown","items":[{"doc":"Provides some convenient functions.","ref":"ElasticsearchEx.html","title":"ElasticsearchEx","type":"module"},{"doc":"Refer to `ElasticsearchEx.Api.Search.search/2` documentation.","ref":"ElasticsearchEx.html#index/2","title":"ElasticsearchEx.index/2","type":"function"},{"doc":"Refer to `ElasticsearchEx.Api.Search.search/2` documentation.","ref":"ElasticsearchEx.html#search/2","title":"ElasticsearchEx.search/2","type":"function"},{"doc":"","ref":"ElasticsearchEx.html#t:response/0","title":"ElasticsearchEx.response/0","type":"type"},{"doc":"Provides the APIs for the single document operations.","ref":"ElasticsearchEx.Api.Document.html","title":"ElasticsearchEx.Api.Document","type":"module"},{"doc":"Adds a JSON document to the specified data stream or index and makes it searchable.\n\n#","ref":"ElasticsearchEx.Api.Document.html#create/2","title":"ElasticsearchEx.Api.Document.create/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-index_.html#docs-index-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Document.html#create/2-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Document.create/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-index_.html#docs-index-api-request-body)\nfor a detailed list of the body values.\n\n#","ref":"ElasticsearchEx.Api.Document.html#create/2-request-body","title":"Request body - ElasticsearchEx.Api.Document.create/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Document.create(\n    ...>   %{\n    ...>     \"@timestamp\": \"2099-11-15T13:12:00\",\n    ...>     message: \"GET /search HTTP/1.1 200 1070000\",\n    ...>     user: %{id: \"kimchy\"}\n    ...>   },\n    ...>   index: \"my-index-000001\",\n    ...>   id: \"W0tpsmIBdwcYyG50zbta\"\n    ...> )\n    {:ok,\n     %{\n       \"_id\" => \"W0tpsmIBdwcYyG50zbta\",\n       \"_index\" => \"my-index-000001\",\n       \"_primary_term\" => 1,\n       \"_seq_no\" => 0,\n       \"_shards\" => %{\"failed\" => 0, \"successful\" => 2, \"total\" => 2},\n       \"_version\" => 1,\n       \"result\" => \"created\"\n     }}","ref":"ElasticsearchEx.Api.Document.html#create/2-examples","title":"Examples - ElasticsearchEx.Api.Document.create/2","type":"function"},{"doc":"Removes a JSON document from the specified index.\n\n#","ref":"ElasticsearchEx.Api.Document.html#delete/1","title":"ElasticsearchEx.Api.Document.delete/1","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-delete.html#docs-delete-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Document.html#delete/1-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Document.delete/1","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Document.delete(index: \"my-index-000001\", id: \"0\")\n    {:ok,\n     %{\n       \"_id\" => \"0\",\n       \"_index\" => \"my-index-000001\",\n       \"_primary_term\" => 3,\n       \"_seq_no\" => 6,\n       \"_shards\" => %{\"failed\" => 0, \"successful\" => 1, \"total\" => 2},\n       \"_version\" => 2,\n       \"result\" => \"deleted\"\n     }}\n\n    iex> ElasticsearchEx.Api.Document.delete(index: \"my-index-000001\", id: \"1\")\n    {:error,\n     %ElasticsearchEx.Error{\n       reason: \"Document with ID: `1` not found\",\n       root_cause: nil,\n       status: 404,\n       type: \"not_found\",\n       ...\n     }}","ref":"ElasticsearchEx.Api.Document.html#delete/1-examples","title":"Examples - ElasticsearchEx.Api.Document.delete/1","type":"function"},{"doc":"Checks if the specified JSON document from an index exists.\n\n#","ref":"ElasticsearchEx.Api.Document.html#document_exists?/1","title":"ElasticsearchEx.Api.Document.document_exists?/1","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-get.html#docs-get-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Document.html#document_exists?/1-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Document.document_exists?/1","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Document.document_exists?(index: \"my-index-000001\", id: \"0\")\n    true","ref":"ElasticsearchEx.Api.Document.html#document_exists?/1-examples","title":"Examples - ElasticsearchEx.Api.Document.document_exists?/1","type":"function"},{"doc":"Retrieves the specified JSON document from an index.\n\n#","ref":"ElasticsearchEx.Api.Document.html#get_document/1","title":"ElasticsearchEx.Api.Document.get_document/1","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-get.html#docs-get-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Document.html#get_document/1-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Document.get_document/1","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Document.get_document(index: \"my-index-000001\", id: \"0\")\n    {:ok,\n     %{\n       \"_id\" => \"0\",\n       \"_index\" => \"my-index-000001\",\n       \"_primary_term\" => 1,\n       \"_seq_no\" => 0,\n       \"_source\" => %{\n         \"@timestamp\" => \"2099-11-15T14:12:12\",\n         \"http\" => %{\n           \"request\" => %{\"method\" => \"get\"},\n           \"response\" => %{\"bytes\" => 1070000, \"status_code\" => 200},\n           \"version\" => \"1.1\"\n         },\n         \"message\" => \"GET /search HTTP/1.1 200 1070000\",\n         \"source\" => %{\"ip\" => \"127.0.0.1\"},\n         \"user\" => %{\"id\" => \"kimchy\"}\n       },\n       \"_version\" => 1,\n       \"found\" => true\n     }}","ref":"ElasticsearchEx.Api.Document.html#get_document/1-examples","title":"Examples - ElasticsearchEx.Api.Document.get_document/1","type":"function"},{"doc":"Retrieves the specified JSON source from an index.\n\n#","ref":"ElasticsearchEx.Api.Document.html#get_source/1","title":"ElasticsearchEx.Api.Document.get_source/1","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-get.html#docs-get-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Document.html#get_source/1-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Document.get_source/1","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Document.get_source(index: \"my-index-000001\", id: \"0\")\n    {:ok,\n     %{\n       \"@timestamp\" => \"2099-11-15T14:12:12\",\n       \"http\" => %{\n         \"request\" => %{\"method\" => \"get\"},\n         \"response\" => %{\"bytes\" => 1_070_000, \"status_code\" => 200},\n         \"version\" => \"1.1\"\n       },\n       \"message\" => \"GET /search HTTP/1.1 200 1070000\",\n       \"source\" => %{\"ip\" => \"127.0.0.1\"},\n       \"user\" => %{\"id\" => \"kimchy\"}\n     }}","ref":"ElasticsearchEx.Api.Document.html#get_source/1-examples","title":"Examples - ElasticsearchEx.Api.Document.get_source/1","type":"function"},{"doc":"Adds a JSON document to the specified data stream or index and makes it searchable. If the\ntarget is an index and the document already exists, the request updates the document and\nincrements its version.\n\n#","ref":"ElasticsearchEx.Api.Document.html#index/2","title":"ElasticsearchEx.Api.Document.index/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-index_.html#docs-index-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Document.html#index/2-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Document.index/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-index_.html#docs-index-api-request-body)\nfor a detailed list of the body values.\n\n#","ref":"ElasticsearchEx.Api.Document.html#index/2-request-body","title":"Request body - ElasticsearchEx.Api.Document.index/2","type":"function"},{"doc":"Without a specific document ID:\n\n    iex> ElasticsearchEx.Api.Document.index(\n    ...>   %{\n    ...>     \"@timestamp\": \"2099-11-15T13:12:00\",\n    ...>     message: \"GET /search HTTP/1.1 200 1070000\",\n    ...>     user: %{id: \"kimchy\"}\n    ...>   },\n    ...>   index: \"my-index-000001\"\n    ...> )\n    {:ok,\n     %{\n       \"_id\" => \"W0tpsmIBdwcYyG50zbta\",\n       \"_index\" => \"my-index-000001\",\n       \"_primary_term\" => 1,\n       \"_seq_no\" => 0,\n       \"_shards\" => %{\"failed\" => 0, \"successful\" => 2, \"total\" => 2},\n       \"_version\" => 1,\n       \"result\" => \"created\"\n     }}\n\nWith a specific document ID:\n\n    iex> ElasticsearchEx.Api.Document.index(\n    ...>   %{\n    ...>     \"@timestamp\": \"2099-11-15T13:12:00\",\n    ...>     message: \"GET /search HTTP/1.1 200 1070000\",\n    ...>     user: %{id: \"kimchy\"}\n    ...>   },\n    ...>   index: \"my-index-000001\",\n    ...>   id: \"W0tpsmIBdwcYyG50zbta\"\n    ...> )\n    {:ok,\n     %{\n       \"_id\" => \"W0tpsmIBdwcYyG50zbta\",\n       \"_index\" => \"my-index-000001\",\n       \"_primary_term\" => 1,\n       \"_seq_no\" => 0,\n       \"_shards\" => %{\"failed\" => 0, \"successful\" => 2, \"total\" => 2},\n       \"_version\" => 1,\n       \"result\" => \"created\"\n     }}","ref":"ElasticsearchEx.Api.Document.html#index/2-examples","title":"Examples - ElasticsearchEx.Api.Document.index/2","type":"function"},{"doc":"Checks if the specified JSON source from an index exists.\n\n#","ref":"ElasticsearchEx.Api.Document.html#source_exists?/1","title":"ElasticsearchEx.Api.Document.source_exists?/1","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-get.html#docs-get-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Document.html#source_exists?/1-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Document.source_exists?/1","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Document.source_exists?(index: \"my-index-000001\", id: \"0\")\n    true","ref":"ElasticsearchEx.Api.Document.html#source_exists?/1-examples","title":"Examples - ElasticsearchEx.Api.Document.source_exists?/1","type":"function"},{"doc":"Updates a document using the specified script.\n\n#","ref":"ElasticsearchEx.Api.Document.html#update/2","title":"ElasticsearchEx.Api.Document.update/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-update.html#docs-update-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Document.html#update/2-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Document.update/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/docs-update.html#update-api-example)\nfor a detailed list of the body values.\n\n#","ref":"ElasticsearchEx.Api.Document.html#update/2-request-body","title":"Request body - ElasticsearchEx.Api.Document.update/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Document.update(\n    ...>   %{\n    ...>     script: %{\n    ...>       source: \"ctx._source.message = params.message\",\n    ...>       lang: \"painless\",\n    ...>       params: %{message: \"Bye World\"}\n    ...>     }\n    ...>   },\n    ...>   index: \"my-index-000001\",\n    ...>   id: \"0\"\n    ...> )\n    {:ok,\n     %{\n       \"_id\" => \"0\",\n       \"_index\" => \"my-index-000001\",\n       \"_primary_term\" => 1,\n       \"_seq_no\" => 1,\n       \"_version\" => 2,\n       \"_shards\" => %{\"failed\" => 0, \"successful\" => 1, \"total\" => 1},\n       \"result\" => \"updated\"\n     }}","ref":"ElasticsearchEx.Api.Document.html#update/2-examples","title":"Examples - ElasticsearchEx.Api.Document.update/2","type":"function"},{"doc":"Search APIs are used to search and aggregate data stored in Elasticsearch indices and data streams. For an overview and related tutorials, see [The search API](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-your-data.html).\n\nMost search APIs support [multi-target syntax](https://www.elastic.co/guide/en/elasticsearch/reference/current/api-conventions.html#api-multi-index), with the exception of the [explain API](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-explain.html).","ref":"ElasticsearchEx.Api.Search.html","title":"ElasticsearchEx.Api.Search","type":"module"},{"doc":"Executes a search request asynchronously. It accepts the same parameters and request body as the\n[search API](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-search.html).\n\n#","ref":"ElasticsearchEx.Api.Search.html#async_search/2","title":"ElasticsearchEx.Api.Search.async_search/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-search.html#search-search-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Search.html#async_search/2-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Search.async_search/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-search.html#search-search-api-request-body)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Search.html#async_search/2-request-body","title":"Request body - ElasticsearchEx.Api.Search.async_search/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.async_search(\n    ...>   %{\n    ...>     aggs: %{sale_date: %{date_histogram: %{calendar_interval: \"1d\", field: \"date\"}}},\n    ...>     sort: [%{date: %{order: \"asc\"}}]\n    ...>   },\n    ...>   size: 0\n    ...> )\n    {:ok,\n     %{\n       \"expiration_time_in_millis\" => 1584377890986,\n       \"id\" => \"FmRldE8zREVEUzA2ZVpUeGs2ejJFUFEaMkZ5QTVrSTZSaVN3WlNFVmtlWHJsdzoxMDc=\",\n       \"is_partial\" => true,\n       \"is_running\" => true,\n       \"response\" => %{\n         \"_shards\" => %{\n           \"failed\" => 0,\n           \"skipped\" => 0,\n           \"successful\" => 3,\n           \"total\" => 562\n         },\n         \"hits\" => %{\n           \"hits\" => [],\n           \"max_score\" => nil,\n           \"total\" => %{\"relation\" => \"gte\", \"value\" => 157483}\n         },\n         \"num_reduce_phases\" => 0,\n         \"timed_out\" => false,\n         \"took\" => 1122\n       },\n       \"start_time_in_millis\" => 1583945890986\n     }}","ref":"ElasticsearchEx.Api.Search.html#async_search/2-examples","title":"Examples - ElasticsearchEx.Api.Search.async_search/2","type":"function"},{"doc":"Clears the search context and results for a scrolling search.\n\n#","ref":"ElasticsearchEx.Api.Search.html#clear_scroll/2","title":"ElasticsearchEx.Api.Search.clear_scroll/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.clear_scroll(\n    ...>   \"FGluY2x1ZGVfY29udGV4dF91dWlkDXF1ZXJ5QW5kRmV0Y2gBFnZaRlo5M2xHUzN1VFdLUUxTUDFXOUEAAAAAAAAAWRZBdENUeTlIalF2bWs4WGlOaEVFZTd3\"\n    ...> )\n    {:ok, %{\"num_freed\" => 1, \"succeeded\" => true}}","ref":"ElasticsearchEx.Api.Search.html#clear_scroll/2-examples","title":"Examples - ElasticsearchEx.Api.Search.clear_scroll/2","type":"function"},{"doc":"Point-in-time is automatically closed when its `keep_alive` has been elapsed. However keeping\npoint-in-times has a cost. Point-in-times should be closed as soon as they are no longer used in\nsearch requests.\n\n#","ref":"ElasticsearchEx.Api.Search.html#close_pit/2","title":"ElasticsearchEx.Api.Search.close_pit/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.close_pit(\"gcSHBAEJb2Jhbl9qb2JzFmJsOTBBMHEwUTVld19yQ3RBYkEtSVEAFkF0Q1R5OUhqUXZtazhYaU5oRUVlN3cAAAAAAAAAAFUWdlpGWjkzbEdTM3VUV0tRTFNQMVc5QQABFmJsOTBBMHEwUTVld19yQ3RBYkEtSVEAAA==\")\n    {:ok, %{\"num_freed\" => 1, \"succeeded\" => true}}","ref":"ElasticsearchEx.Api.Search.html#close_pit/2-examples","title":"Examples - ElasticsearchEx.Api.Search.close_pit/2","type":"function"},{"doc":"A search request by default executes against the most recent visible data of the target indices,\nwhich is called point in time. Elasticsearch `pit` (point in time) is a lightweight view into the\nstate of the data as it existed when initiated. In some cases, it’s preferred to perform multiple\nsearch requests using the same point in time. For example, if refreshes happen between\n`search_after` requests, then the results of those requests might not be consistent as changes\nhappening between searches are only visible to the more recent point in time.\n\n#","ref":"ElasticsearchEx.Api.Search.html#create_pit/1","title":"ElasticsearchEx.Api.Search.create_pit/1","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.create_pit(index: :my-index-000001, keep_alive: \"5m\")\n    {:ok,\n     %{\n       \"id\" => \"gcSHBAEJb2Jhbl9qb2JzFmJsOTBBMHEwUTVld19yQ3RBYkEtSVEAFkF0Q1R5OUhqUXZtazhYaU5oRUVlN3cAAAAAAAAAAFUWdlpGWjkzbEdTM3VUV0tRTFNQMVc5QQABFmJsOTBBMHEwUTVld19yQ3RBYkEtSVEAAA==\"\n     }}","ref":"ElasticsearchEx.Api.Search.html#create_pit/1-examples","title":"Examples - ElasticsearchEx.Api.Search.create_pit/1","type":"function"},{"doc":"You can use the delete async search API to manually delete an async search by ID.\nIf the search is still running, the search request will be cancelled. Otherwise, the saved\nsearch results are deleted.\n\n#","ref":"ElasticsearchEx.Api.Search.html#delete_async_search/2","title":"ElasticsearchEx.Api.Search.delete_async_search/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.delete_async_search(\"FmRldE8zREVEUzA2ZVpUeGs2ejJFUFEaMkZ5QTVrSTZSaVN3WlNFVmtlWHJsdzoxMDc=\")\n    nil","ref":"ElasticsearchEx.Api.Search.html#delete_async_search/2-examples","title":"Examples - ElasticsearchEx.Api.Search.delete_async_search/2","type":"function"},{"doc":"The get async search API retrieves the results of a previously submitted async search request\ngiven its id.\n\n#","ref":"ElasticsearchEx.Api.Search.html#get_async_search/2","title":"ElasticsearchEx.Api.Search.get_async_search/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.get_async_search(\"FmRldE8zREVEUzA2ZVpUeGs2ejJFUFEaMkZ5QTVrSTZSaVN3WlNFVmtlWHJsdzoxMDc=\")\n    {:ok,\n     %{\n       \"completion_time_in_millis\" => 1583945903130,\n       \"expiration_time_in_millis\" => 1584377890986,\n       \"id\" => \"FmRldE8zREVEUzA2ZVpUeGs2ejJFUFEaMkZ5QTVrSTZSaVN3WlNFVmtlWHJsdzoxMDc=\",\n       \"is_partial\" => false,\n       \"is_running\" => false,\n       \"response\" => %{\n         \"_shards\" => %{\n           \"failed\" => 0,\n           \"skipped\" => 0,\n           \"successful\" => 188,\n           \"total\" => 562\n         },\n         \"aggregations\" => %{\"sale_date\" => %{\"buckets\" => []}},\n         \"hits\" => %{\n           \"hits\" => [],\n           \"max_score\" => nil,\n           \"total\" => %{\"relation\" => \"eq\", \"value\" => 456433}\n         },\n         \"num_reduce_phases\" => 46,\n         \"timed_out\" => false,\n         \"took\" => 12144\n       },\n       \"start_time_in_millis\" => 1583945890986\n     }}","ref":"ElasticsearchEx.Api.Search.html#get_async_search/2-examples","title":"Examples - ElasticsearchEx.Api.Search.get_async_search/2","type":"function"},{"doc":"The get async search status API, without retrieving search results, shows only the status of a\npreviously submitted async search request given its id.\n\n#","ref":"ElasticsearchEx.Api.Search.html#get_async_search_status/2","title":"ElasticsearchEx.Api.Search.get_async_search_status/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.get_async_search_status(\"FmRldE8zREVEUzA2ZVpUeGs2ejJFUFEaMkZ5QTVrSTZSaVN3WlNFVmtlWHJsdzoxMDc=\")\n    {:ok,\n     %{\n       \"_shards\" => %{\n         \"failed\" => 0,\n         \"skipped\" => 0,\n         \"successful\" => 188,\n         \"total\" => 562\n       },\n       \"expiration_time_in_millis\" => 1584377890986,\n       \"id\" => \"FmRldE8zREVEUzA2ZVpUeGs2ejJFUFEaMkZ5QTVrSTZSaVN3WlNFVmtlWHJsdzoxMDc=\",\n       \"is_partial\" => true,\n       \"is_running\" => true,\n       \"start_time_in_millis\" => 1583945890986\n     }}","ref":"ElasticsearchEx.Api.Search.html#get_async_search_status/2-examples","title":"Examples - ElasticsearchEx.Api.Search.get_async_search_status/2","type":"function"},{"doc":"Point-in-time is automatically closed when its `keep_alive` has been elapsed. However keeping\npoint-in-times has a cost. Point-in-times should be closed as soon as they are no longer used in\nsearch requests.\n\n#","ref":"ElasticsearchEx.Api.Search.html#get_scroll/2","title":"ElasticsearchEx.Api.Search.get_scroll/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.get_scroll(\n    ...>   \"FGluY2x1ZGVfY29udGV4dF91dWlkDXF1ZXJ5QW5kRmV0Y2gBFnZaRlo5M2xHUzN1VFdLUUxTUDFXOUEAAAAAAAAAWRZBdENUeTlIalF2bWs4WGlOaEVFZTd3\",\n    ...>   scroll: \"1m\"\n    ...> )\n    {:ok,\n     %{\n       \"_scroll_id\" => \"FGluY2x1ZGVfY29udGV4dF91dWlkDXF1ZXJ5QW5kRmV0Y2gBFnZaRlo5M2xHUzN1VFdLUUxTUDFXOUEAAAAAAAAAXRZBdENUeTlIalF2bWs4WGlOaEVFZTd3\",\n       \"_shards\" => %{\n         \"failed\" => 0,\n         \"skipped\" => 0,\n         \"successful\" => 1,\n         \"total\" => 1\n       },\n       \"hits\" => %{\n         \"hits\" => [],\n         \"max_score\" => nil,\n         \"total\" => %{\"relation\" => \"eq\", \"value\" => 3}\n       },\n       \"timed_out\" => false,\n       \"took\" => 1\n     }}","ref":"ElasticsearchEx.Api.Search.html#get_scroll/2-examples","title":"Examples - ElasticsearchEx.Api.Search.get_scroll/2","type":"function"},{"doc":"Executes several searches with a single API request.\n\n#","ref":"ElasticsearchEx.Api.Search.html#multi_search/2","title":"ElasticsearchEx.Api.Search.multi_search/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-multi-search.html#search-multi-search-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Search.html#multi_search/2-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Search.multi_search/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-multi-search.html#search-multi-search-api-request-body)\nfor a detailed list of the body values.\n\n#","ref":"ElasticsearchEx.Api.Search.html#multi_search/2-request-body","title":"Request body - ElasticsearchEx.Api.Search.multi_search/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.multi_search(\n    ...>   [\n    ...>     %{},\n    ...>     %{\"query\" => %{\"match\" => %{\"message\" => \"this is a test\"}}},\n    ...>     %{\"index\" => \"my-index-000002\"},\n    ...>     %{\"query\" => %{\"match_all\" => %{}}}\n    ...>   ],\n    ...>   allow_no_indices: false\n    ...> )\n    {:ok,\n     %{\n       \"responses\" => [\n         %{\n           \"_shards\" => %{\n             \"failed\" => 0,\n             \"skipped\" => 0,\n             \"successful\" => 2,\n             \"total\" => 2\n           },\n           \"hits\" => %{\n             \"hits\" => [\n              %{\n                 \"_id\" => \"8-aORIwBU7w6JJjT4O86\",\n                 \"_index\" => \"my-index-000001\",\n                 \"_score\" => 1.0,\n                 \"_source\" => %{\n                   \"message\": \"this is a test\"\n                 }\n               }\n             ],\n             \"max_score\" => nil,\n             \"total\" => %{\"relation\" => \"eq\", \"value\" => 0}\n           },\n           \"status\" => 200,\n           \"timed_out\" => false,\n           \"took\" => 14\n         },\n         %{\n           \"_shards\" => %{\n             \"failed\" => 0,\n             \"skipped\" => 0,\n             \"successful\" => 1,\n             \"total\" => 1\n           },\n           \"hits\" => %{\n             \"hits\" => [\n               %{\n                 \"_id\" => \"8uaORIwBU7w6JJjTX-8-\",\n                 \"_index\" => \"my-index-000002\",\n                 \"_score\" => 1.0,\n                 \"_source\" => %{\n                   \"message\": \"this another test\"\n                 }\n               }\n             ],\n             \"max_score\" => 1.0,\n             \"total\" => %{\"relation\" => \"eq\", \"value\" => 3}\n           },\n           \"status\" => 200,\n           \"timed_out\" => false,\n           \"took\" => 11\n         }\n       ],\n       \"took\" => 21\n     }}","ref":"ElasticsearchEx.Api.Search.html#multi_search/2-examples","title":"Examples - ElasticsearchEx.Api.Search.multi_search/2","type":"function"},{"doc":"Returns search hits that match the query defined in the request.\n\nIt expects the first argument to be a valid Elasticsearch query represented by an Elixir `Map`.\n\n#","ref":"ElasticsearchEx.Api.Search.html#search/2","title":"ElasticsearchEx.Api.Search.search/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-search.html#search-search-api-query-params)\nfor a detailed list of the parameters.\n\n#","ref":"ElasticsearchEx.Api.Search.html#search/2-query-parameters","title":"Query parameters - ElasticsearchEx.Api.Search.search/2","type":"function"},{"doc":"Refer to the official [documentation](https://www.elastic.co/guide/en/elasticsearch/reference/current/search-search.html#search-search-api-request-body)\nfor a detailed list of the body values.\n\n#","ref":"ElasticsearchEx.Api.Search.html#search/2-request-body","title":"Request body - ElasticsearchEx.Api.Search.search/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.search(%{query: %{term: %{\"user.id\": \"kimchy\"}}},\n    ...>   from: 40,\n    ...>   size: 20\n    ...> )\n    {:ok,\n     %{\n       \"_shards\" => %{\n         \"failed\" => 0,\n         \"skipped\" => 0,\n         \"successful\" => 1,\n         \"total\" => 1\n       },\n       \"hits\" => %{\n         \"hits\" => [\n           %{\n             \"_id\" => \"0\",\n             \"_index\" => \"my-index-000001\",\n             \"_score\" => 1.3862942,\n             \"_source\" => %{\n               \"@timestamp\" => \"2099-11-15T14:12:12\",\n               \"http\" => %{\n                 \"request\" => %{\"method\" => \"get\"},\n                 \"response\" => %{\"bytes\" => 1070000, \"status_code\" => 200},\n                 \"version\" => \"1.1\"\n               },\n               \"message\" => \"GET /search HTTP/1.1 200 1070000\",\n               \"source\" => %{\"ip\" => \"127.0.0.1\"},\n               \"user\" => %{\"id\" => \"kimchy\"}\n             }\n           },\n           ...\n         ],\n         \"max_score\" => 1.3862942,\n         \"total\" => %{\"relation\" => \"eq\", \"value\" => 20}\n       },\n       \"timed_out\" => false,\n       \"took\" => 5\n     }}","ref":"ElasticsearchEx.Api.Search.html#search/2-examples","title":"Examples - ElasticsearchEx.Api.Search.search/2","type":"function"},{"doc":"The terms enum API can be used to discover terms in the index that match a partial string.\n\nSupported field types are `keyword`, `constant_keyword`, `flattened`, `version` and `ip`.\n\nThis is used for auto-complete.\n\n#","ref":"ElasticsearchEx.Api.Search.html#terms_enum/2","title":"ElasticsearchEx.Api.Search.terms_enum/2","type":"function"},{"doc":"iex> ElasticsearchEx.Api.Search.terms_enum(%{\"field\" => \"tags\", \"string\" => \"kiba\"},\n    ...>   index: \"stackoverflow\"\n    ...> )\n    {:ok,\n     %{\n       \"_shards\" => %{\"failed\" => 0, \"successful\" => 1, \"total\" => 1},\n       \"complete\" => true,\n       \"terms\" => [\"kibana\"]\n     }}","ref":"ElasticsearchEx.Api.Search.html#terms_enum/2-examples","title":"Examples - ElasticsearchEx.Api.Search.terms_enum/2","type":"function"},{"doc":"Provides some helpers to make the HTTP calls easier by extracting and manipulating options.","ref":"ElasticsearchEx.Api.Utils.html","title":"ElasticsearchEx.Api.Utils","type":"module"},{"doc":"Extracts from the `opts` the index and the other options.","ref":"ElasticsearchEx.Api.Utils.html#extract_optional_index/2","title":"ElasticsearchEx.Api.Utils.extract_optional_index/2","type":"function"},{"doc":"Extracts from the `opts` the index and the other options.\n\nRaises an exception if the option `index` is missing.","ref":"ElasticsearchEx.Api.Utils.html#extract_required_index!/1","title":"ElasticsearchEx.Api.Utils.extract_required_index!/1","type":"function"},{"doc":"Extracts from the `opts`, the key `index` and `id`.\n\nRaises an exception if the `index` key is missing.","ref":"ElasticsearchEx.Api.Utils.html#extract_required_index_and_optional_id!/1","title":"ElasticsearchEx.Api.Utils.extract_required_index_and_optional_id!/1","type":"function"},{"doc":"Extracts from the `opts`, the key `index` and `id`.\n\nRaises an exception if the `index` or the `id` keys are missing.","ref":"ElasticsearchEx.Api.Utils.html#extract_required_index_and_required_id!/1","title":"ElasticsearchEx.Api.Utils.extract_required_index_and_required_id!/1","type":"function"},{"doc":"Takes all the items of the list and merge to a valid URL.\n\nRemoves the `nil` values and add a leading `/`.","ref":"ElasticsearchEx.Api.Utils.html#merge_path_items/1","title":"ElasticsearchEx.Api.Utils.merge_path_items/1","type":"function"},{"doc":"","ref":"ElasticsearchEx.Api.Utils.html#t:id/0","title":"ElasticsearchEx.Api.Utils.id/0","type":"type"},{"doc":"","ref":"ElasticsearchEx.Api.Utils.html#t:index/0","title":"ElasticsearchEx.Api.Utils.index/0","type":"type"},{"doc":"","ref":"ElasticsearchEx.Api.Utils.html#t:opts/0","title":"ElasticsearchEx.Api.Utils.opts/0","type":"type"},{"doc":"Provides the functions to make HTTP calls.","ref":"ElasticsearchEx.Client.html","title":"ElasticsearchEx.Client","type":"module"},{"doc":"","ref":"ElasticsearchEx.Client.html#delete/4","title":"ElasticsearchEx.Client.delete/4","type":"function"},{"doc":"","ref":"ElasticsearchEx.Client.html#get/4","title":"ElasticsearchEx.Client.get/4","type":"function"},{"doc":"","ref":"ElasticsearchEx.Client.html#head/3","title":"ElasticsearchEx.Client.head/3","type":"function"},{"doc":"","ref":"ElasticsearchEx.Client.html#post/4","title":"ElasticsearchEx.Client.post/4","type":"function"},{"doc":"","ref":"ElasticsearchEx.Client.html#put/4","title":"ElasticsearchEx.Client.put/4","type":"function"},{"doc":"","ref":"ElasticsearchEx.Client.html#request/5","title":"ElasticsearchEx.Client.request/5","type":"function"},{"doc":"Provides some helpers to manipulate NDJSON (Newline Delimited JSON).","ref":"ElasticsearchEx.Ndjson.html","title":"ElasticsearchEx.Ndjson","type":"module"},{"doc":"Decodes a binary into a list of `term`.\n\nRaises an exception if the JSON decoding fails.\n\n#","ref":"ElasticsearchEx.Ndjson.html#decode!/1","title":"ElasticsearchEx.Ndjson.decode!/1","type":"function"},{"doc":"iex> ElasticsearchEx.Ndjson.decode!(\"{\\\"a\\\":\\\"b\\\"}\\n{\\\"c\\\":\\\"d\\\"}\\n\")\n    [%{a: :b}, %{c: :d}]","ref":"ElasticsearchEx.Ndjson.html#decode!/1-examples","title":"Examples - ElasticsearchEx.Ndjson.decode!/1","type":"function"},{"doc":"Encodes a list of values into a valid NDJSON.\n\nRaises an exception if the JSON encoding fails.\n\n#","ref":"ElasticsearchEx.Ndjson.html#encode!/1","title":"ElasticsearchEx.Ndjson.encode!/1","type":"function"},{"doc":"iex> ElasticsearchEx.Ndjson.encode!([%{a: :b}, %{c: :d}])\n    \"{\\\"a\\\":\\\"b\\\"}\\n{\\\"c\\\":\\\"d\\\"}\\n\"","ref":"ElasticsearchEx.Ndjson.html#encode!/1-examples","title":"Examples - ElasticsearchEx.Ndjson.encode!/1","type":"function"},{"doc":"Wraps the HTTP error into an Elixir exception.","ref":"ElasticsearchEx.Error.html","title":"ElasticsearchEx.Error","type":"exception"},{"doc":"","ref":"ElasticsearchEx.Error.html#t:t/0","title":"ElasticsearchEx.Error.t/0","type":"type"},{"doc":"# Elasticsearch\n\n`elasticsearch_ex` allows to interact with [Elasticsearch](https://www.elastic.co/guide/en/elasticsearch/reference/current/index.html) cluster.","ref":"readme.html","title":"Elasticsearch","type":"extras"},{"doc":"```elixir\ndef deps do\n  [\n    {:elasticsearch_ex, \"~> 0.5\"}\n  ]\nend\n```\n\nDocumentation can be found at https://hexdocs.pm/elasticsearch_ex.","ref":"readme.html#installation","title":"Installation - Elasticsearch","type":"extras"},{"doc":"#","ref":"readme.html#usage","title":"Usage - Elasticsearch","type":"extras"},{"doc":"```elixir\n# Define the `any_http` client adapter\nconfig :any_http, client_adapter: AnyHttp.Adapters.Httpc\n\n# Configure ElasticsearchEx\nconfig :elasticsearch_ex,\n  clusters: %{\n    default: %{\n      endpoint: \"https://elastic:elastic@localhost:9200\",\n      # For development only, if not specified, SSL is configured for you.\n      http_opts: [ssl: [verify: :verify_none]]\n    }\n  }\n```\n\n#","ref":"readme.html#configure-your-cluster","title":"Configure your cluster - Elasticsearch","type":"extras"},{"doc":"```elixir\nElasticsearchEx.index(%{message: \"Hello World!\"}, index: \"my-index\")\n```\n\n#","ref":"readme.html#index-a-document","title":"Index a document - Elasticsearch","type":"extras"},{"doc":"You can easily query your local Elasticsearch with:\n```elixir\nElasticsearchEx.search(%{query: %{match_all: %{}}, size: 1}, index: \"my-index\")\n```\n\nResponse:\n```elixir\n{:ok,\n %{\n   \"_shards\" => %{\n     \"failed\" => 0,\n     \"skipped\" => 0,\n     \"successful\" => 2,\n     \"total\" => 2\n   },\n   \"hits\" => %{\n     \"hits\" => [\n       %{\n         \"_id\" => \"8uaORIwBU7w6JJjTX-8-\",\n         \"_index\" => \"my-index\",\n         \"_score\" => 1.0,\n         \"_source\" => %{\n           \"message\" => \"Hello World!\"\n         }\n       }\n     ],\n     \"max_score\" => 1.0,\n     \"total\" => %{\"relation\" => \"eq\", \"value\" => 1}\n   },\n   \"timed_out\" => false,\n   \"took\" => 7\n }}\n```","ref":"readme.html#search-your-cluster","title":"Search your cluster - Elasticsearch","type":"extras"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* **Changes:**\n  * Updated the dependencies\n  * Updated Erlang/Elixir/Elasticsearch versions in the testing matrix","ref":"changelog.html#v0-6-2-2024-04-01","title":"v0.6.2 (2024-04-01) - Changelog","type":"extras"},{"doc":"* **Changes:**\n  * Removed an option from the package preventing Dialyzer to work properly when it's used as dependency","ref":"changelog.html#v0-6-1-2023-12-28","title":"v0.6.1 (2023-12-28) - Changelog","type":"extras"},{"doc":"* **New features:**\n  * Delegated `ElasticsearchEx.index/2`\n\n* **Changes:**\n  * Renamed the modules to remove the scope (tests are untouched)\n  * Added more tests\n  * Updated the dependency `any_http` to get rid of the issue with Dialyzer\n\n* **Bug fixes:**\n  * Fixed a bug on `ElasticsearchEx.Api.Document.update/2` preventing to update.","ref":"changelog.html#v0-6-0-2023-12-28","title":"v0.6.0 (2023-12-28) - Changelog","type":"extras"},{"doc":"* **New features:**\n  * Added the ability to specify clusters which configure an endpoint, default headers and default\n  options\n\n* **Changes:**\n  * Removed the function to make `PATCH` request which isn't used by Elasticsearch\n  * Removed most of the Dialyzer types causing issues\n  * Added all the tests for `ElasticsearchEx.Api.Search`\n\n* **Bug fixes:**\n  * Fixed an issue preventing to make `POST` request without body","ref":"changelog.html#v0-5-0-2023-12-20","title":"v0.5.0 (2023-12-20) - Changelog","type":"extras"},{"doc":"* **New features:**\n  * Added new functions related to single document operations:\n    * `ElasticsearchEx.Api.Document.index/2`\n    * `ElasticsearchEx.Api.Document.create/2`\n    * `ElasticsearchEx.Api.Document.get_document/1`\n    * `ElasticsearchEx.Api.Document.get_source/1`\n    * `ElasticsearchEx.Api.Document.document_exists?/1`\n    * `ElasticsearchEx.Api.Document.source_exists?/1`\n    * `ElasticsearchEx.Api.Document.delete/1`\n    * `ElasticsearchEx.Api.Document.update/2`","ref":"changelog.html#v0-4-0-2023-12-19","title":"v0.4.0 (2023-12-19) - Changelog","type":"extras"},{"doc":"* **Changes:**\n  * Added unit tests for:\n    * `ElasticsearchEx.Api.Utils`\n    * `ElasticsearchEx.Client`\n    * `ElasticsearchEx.Error`\n    * `ElasticsearchEx.Ndjson`\n\n* **Bug fixes:**\n  * Fixed the return value for the function `ElasticsearchEx.Client.head/2` in case of error\n  * Fixed the typespec for the function `ElasticsearchEx.Client.head/2` in case of error\n  * Added the ability to have no body to create an exception with `ElasticsearchEx.Error`\n  * Ensured the `ElasticsearchEx.Error.original` attribute is provided","ref":"changelog.html#v0-3-1-2023-12-19","title":"v0.3.1 (2023-12-19) - Changelog","type":"extras"},{"doc":"* **New features:**\n  * Added new functions related to `async_search`:\n    - `ElasticsearchEx.Api.Search.async_search/2`\n    - `ElasticsearchEx.Api.Search.get_async_search/2`\n    - `ElasticsearchEx.Api.Search.get_async_search_status/2`\n    - `ElasticsearchEx.Api.Search.delete_async_search/2`\n  * Added new functions related to `pit`:\n    - `ElasticsearchEx.Api.Search.create_pit/1`\n    - `ElasticsearchEx.Api.Search.close_pit/2`\n  * Added new functions related to `scroll`:\n    - `ElasticsearchEx.Api.Search.get_scroll/2`\n    - `ElasticsearchEx.Api.Search.clear_scroll/2`\n  * Added a new module `ElasticsearchEx.Ndjson` to manipulate NDJSON\n  * Added new functions related to `multi_search`:\n    - `ElasticsearchEx.Api.Search.multi_search/2`\n  * Added new functions related to `terms_enum`:\n    - `ElasticsearchEx.Api.Search.terms_enum/2`\n\n* **Changes:**\n  * Added Github actions matrix to test different versions\n  * Changed the development versions of Elixir and Erlang to 1.13.4 and 24.3.4.14","ref":"changelog.html#v0-3-0-2023-12-19","title":"v0.3.0 (2023-12-19) - Changelog","type":"extras"},{"doc":"* **New features:**\n  * Delegated the function `ElasticsearchEx.Api.Search.search/2` in `ElasticsearchEx` module ([PR-4](https://github.com/CoreCareinc/elasticsearch_ex/pull/4))\n  * Added a `ElasticsearchEx.Error` exception to return an error.\n\n* **Changes:**\n  * Added Credo ([PR-2](https://github.com/CoreCareinc/elasticsearch_ex/pull/2))\n  * Added Dialyxir ([PR-3](https://github.com/CoreCareinc/elasticsearch_ex/pull/3))","ref":"changelog.html#v0-2-0-2023-12-18","title":"v0.2.0 (2023-12-18) - Changelog","type":"extras"},{"doc":"* **New features:**\n  * Added the function `ElasticsearchEx.Api.Search.search/2` to search Elasticsearch ([PR-1](https://github.com/CoreCareinc/elasticsearch_ex/pull/1))","ref":"changelog.html#v0-1-0-2023-12-02","title":"v0.1.0 (2023-12-02) - Changelog","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}